﻿"use strict";

class Coord
{
	constructor(x, y)
	{
		this.x = x;
		this.y = y;
	}

	copy()
	{
		return new Coord(this.x, this.y);
	}

	set(coord)
	{
		this.x = coord.x;
		this.y = coord.y;
	}

	setValues(x, y)
	{
		this.x = x;
		this.y = y;
	}
}



function RotateAround(position, origin, angle)
{
	var p1x = position.x - origin.x;
	var p1y = position.y - origin.y;
	var rx = p1x * Math.cos(angle) - p1y * Math.sin(angle);
	var ry = p1x * Math.sin(angle) + p1y * Math.cos(angle);
	return new Coord(rx + origin.x, ry + origin.y);
}



function DistanceBetween(p0, p1)
{
	return Math.sqrt(Math.pow(p0.x - p1.x, 2) + Math.pow(p0.y - p1.y, 2));
}



function LineSegmentsIntersection(position0, direction0, length0, position1, direction1, length1)
{
	if (direction0 === direction1 || direction0 === Rotate180(direction1))
		return null;
	var p1 = RotateAround(position1, position0, -DirectionAngle(direction0));
	p1.x -= position0.x;
	p1.y -= position0.y;
	var ep = GetEndPosition(p1, (direction1 - direction0 + 8) % 8, length1);
	if ((p1.y <= 0 && ep.y <= 0) || (p1.y >= 0 && ep.y >= 0))
		return null;
	var m = (ep.x - p1.x) / (ep.y - p1.y);
	var solutionX = p1.x - m * p1.y;
	if (solutionX < 0 || solutionX > length0)
		return null;
	var solution = new Coord(solutionX, 0);
	//return DistanceBetween(p1, solution);
	solution.x += position0.x;
	solution.y += position0.y;
	return RotateAround(solution, position0, DirectionAngle(direction0));
}