﻿var Key = {
	_pressed: {},
	mode: null,

	LEFT: 37,
	UP: 38,
	RIGHT: 39,
	DOWN: 40,
	ENTER: 13,
	SPACE: 32,
	A: 65,
	D: 68,
	Q: 81,
	S: 83,
	W: 87,

	isDown: function(keyCode) {
		return this._pressed[keyCode];
	},

	onKeydown: function(event) {
		var keyCode = event.keyCode;
		this._pressed[keyCode] = true;
		if (this.mode !== null && this.mode.onKeyDown !== undefined) {
			this.mode.onKeyDown(keyCode);
		}
		if (keyCode === this.SPACE || (keyCode >= Key.LEFT && keyCode <= Key.DOWN))
			event.preventDefault();
	},

	onKeyup: function(event) {
		var keyCode = event.keyCode;
		delete this._pressed[keyCode];
		if (this.mode !== null && this.mode.onKeyUp !== undefined) {
			this.mode.onKeyUp(keyCode);
		}
		if (keyCode === this.SPACE || (keyCode >= Key.LEFT && keyCode <= Key.DOWN))
			event.preventDefault();
	}
};