﻿"use strict";

const TAU = 2 * Math.PI;

var controller;

window.onload = function()
{
	controller = new Controller();
	controller.initialise();
}



class Controller
{
	constructor()
	{
	}

	initialise()
	{
		var canvas = document.getElementById("canvas");
		var context = canvas.getContext("2d");
		this.context = context;
		var contextSizeX = parseInt(canvas.getAttribute("width"));
		var contextSizeY = parseInt(canvas.getAttribute("height"));
		this.display = new Display(context, new Coord(contextSizeX, contextSizeY));

		window.addEventListener("keyup", function(event) { Key.onKeyup(event); }, false);
		window.addEventListener("keydown", function(event) { Key.onKeydown(event); }, false);

		this.game = new Game(controller, this.display);
		this.mode = this.game;
		Key.mode = this.mode;
		this.mode.initialise(Map.EARTH);
		this.startFrameLoop();
	}

	startFrameLoop()
	{
		this._main();
	}

	setPortalMode(nextLevel)
	{
		this.nextLevel = nextLevel;
		this.mode = new Portal(controller, this.display);
		Key.mode = this.mode;
		this.mode.initialise();
	}

	endWormholeSequence()
	{
		this.mode = this.game;
		Key.mode = this.mode;
		this.mode.initialise(this.nextLevel);
	}

	_main()
	{
		window.requestAnimationFrame(globalMain);
		this.mode.frame();
	}
}



function globalMain()
{
	controller._main();
}



function alpha(v0, v1, a)
{
	return v0 * (1 - a) + v1 * a;
}